<template>
    <v-container fluid>
        <v-form fast-fail @submit.prevent="addUser" class="custom">
            <v-row v-for="field in formFields" :key="field.model">
                <v-col class="v-col" cols="12" :md="4">
                    <span style="color: #404040;">{{ field.label }}</span>
                    <v-text-field
                            class="text-eureko"
                            v-model="field.value"
                            :placeholder="field.label"
                            :rules="field.rules"
                            :type="field.type"
                    ></v-text-field>
                </v-col>
            </v-row>
            <v-row>
                <v-col cols="12" md="12" justify="end" class="text-right">
                    <custom-button style="width: 120px;margin-left: 10px" color="primary" size="medium" @click="addUser"
                                   val="Kaydet"/>
                </v-col>
            </v-row>
        </v-form>
        <v-snackbar
                v-model="snackbar"
                :timeout="1500"
                absolute
                centered
                color="deep-purple accent-4"
                elevation="24"
        >
            {{ errorMessage }}
        </v-snackbar>
    </v-container>
</template>

<script>
import UserService from '@/services/UserService.js';
import CustomButton from '@/components/custom-controller/CustomButton.vue';
import {Validation} from '@/utils/validation.js';

export default {
    name: "UserAdd",
    components: {
        CustomButton
    },
    data: () => ({
        snackbar: false,
        errorMessage: '',
        formFields: [
            {
                model: "name",
                value: "",
                label: "Adı",
                type: "text"
            },
            {
                model: "surname",
                value: "",
                label: "Soyadı",
                type: "text"
            },
            {
                model: "username",
                value: "",
                label: "Kullanıcı Adı",
                rules: Validation.nameRule,
                type: "text"
            },
            {
                model: "password",
                value: "",
                label: "Şifre",
                type: "password"
            },
        ]
    }),
    methods: {
        addUser() {
            const request = this.formFields.reduce(
                (acc, field) => ({ ...acc, [field.model]: field.value }),
                {}
            );

            UserService.CreateUser(request)
                .then((response) => {
                    console.log(response)
                })
                .catch((error) => {
                    console.log(error.ErrorMessage)
                    this.errorMessage = 'Lütfen farklı bir kullanıcı adıyla deneyin';
                    this.snackbar = true;
                });
        },


    }
};
</script>

<style scoped>
@import "@/assets/styles/custom/custom-input.css";

</style>